.dockerfiles-containers-set:
  parallel:
    matrix:
      - docker_image_name: noble-balena/linux-x86_64
        VERSION: 20.0.6
        dockerfile: noble-x86_64-balena.Dockerfile
        arch: amd64
        gitlab_job_tag: saas-linux-large-amd64
      - docker_image_name: 2404-x86_64-balena-skopeo/linux-x86_64
        VERSION: 20.0.6
        dockerfile: 2404-x86_64-balena-skopeo.Dockerfile
        arch: amd64
        gitlab_job_tag: saas-linux-large-amd64
      - docker_image_name: nhost_functions_balena/linux-x86_64
        VERSION: 18.1.9
        dockerfile: functions/alpine-nhost-functions-balena-x86_64.Dockerfile
        arch: amd64
        gitlab_job_tag: saas-linux-large-amd64
      - docker_image_name: alpine-chrony/linux-x86_64
        VERSION: 3.15-4.1-r0
        dockerfile: chrony/alpine-x86_64-chrony.Dockerfile
        arch: amd64
        gitlab_job_tag: saas-linux-large-amd64
      - docker_image_name: cargo-c-meson/linux-x86_64
        VERSION: noble-Python3.11
        dockerfile: cargo-c-meson.Dockerfile
        arch: amd64
        gitlab_job_tag: saas-linux-large-amd64
      - docker_image_name: cargo-c-meson/linux-armv8
        VERSION: noble-Python3.11
        dockerfile: cargo-c-meson.Dockerfile
        arch: arm64
        docker_image_arch: arm64v8
        gitlab_job_tag: armv8

.dockerfiles-containers:
  extends:
    - .common-docker
  parallel: !reference [.dockerfiles-containers-set, parallel]
  before_script:
    - docker login -u $CI_DEPENDENCY_PROXY_USER -p $CI_DEPENDENCY_PROXY_PASSWORD $CI_DEPENDENCY_PROXY_SERVER
    - docker login --username $CI_REGISTRY_USER --password $CI_REGISTRY_PASSWORD registry.gitlab.com
  script:
    - docker build . -f $CI_PROJECT_DIR/dockerfiles/$dockerfile --platform linux/${arch} --build-arg VERSION=${VERSION} --tag ${CI_REGISTRY_IMAGE}/${docker_image_name}:${VERSION:-$CI_COMMIT_REF_NAME} --cache-from ${CI_REGISTRY_IMAGE}/${docker_image_name}:${VERSION:-$CI_COMMIT_REF_NAME} --cache-from ${CI_REGISTRY_IMAGE}/${docker_image_name}:latest --cache-from ${CI_REGISTRY_IMAGE}/${docker_image_name}:${CI_DEFAULT_BRANCH}
    - docker push ${CI_REGISTRY_IMAGE}/${docker_image_name}:${VERSION:-$CI_COMMIT_REF_NAME}

dockerfiles-containers-branches:
  extends:
    - .dockerfiles-containers
  rules:
    - if: !reference [.common_rules, on_all_branches_but_default_branch]
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH &&  $CI_COMMIT_TAG == null && $component =~ /.*ob-airgapped-containers.*/

dockerfiles-containers-master:
  extends:
    - .dockerfiles-containers
  after_script:
    - docker tag ${CI_REGISTRY_IMAGE}/${docker_image_name}:${VERSION:-$CI_COMMIT_REF_NAME} ${CI_REGISTRY_IMAGE}/${docker_image_name}:latest
    - docker push ${CI_REGISTRY_IMAGE}/${docker_image_name}:latest
  rules:
    - if: !reference [.common_rules, on_default_branch]
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH && $component =~ /.*ob-airgapped-containers.*/

dockerfiles-containers-tag:
  extends:
    - .dockerfiles-containers
  after_script:
    - docker tag ${CI_REGISTRY_IMAGE}/${docker_image_name}:${VERSION:-$CI_COMMIT_REF_NAME} ${CI_REGISTRY_IMAGE}/${docker_image_name}:latest
    - docker push ${CI_REGISTRY_IMAGE}/${docker_image_name}:latest
  rules:
    - if: !reference [.common_rules, on_tag]
